with Lnko;

package body Racionalisok is

    function Szmll ( R: Racionlis ) return Integer is
    begin
        return R.Szmll;
    end;

    function Nevez ( R: Racionlis ) return Positive is
    begin
        return R.Nevez;
    end;

    function Normalizlva ( Szmll: Integer; Nevez: Positive )
    return Racionlis is
    begin
        if Szmll = 0 then
            return (0,1);
        else
            declare
                H: Positive := Lnko( abs Szmll, Nevez );
            begin
                return (Szmll/H, Nevez/H);
            end;
        end if;
    end;

    function "/" ( Szmll: Integer; Nevez: Positive ) return Racionlis is
    begin
        return Normalizlva( Szmll, Nevez );
    end;

    function "/" ( X, Y: Racionlis ) return Racionlis is
    begin
        return Normalizlva( X.Szmll * Y.Nevez,  X.Nevez * Y.Szmll );
    end;

    function "/" ( X: Racionlis; Y: Positive ) return Racionlis is
    begin
        return Normalizlva( X.Szmll,  X.Nevez * Y );
    end;

    -- function "=" ( X, Y: Racionlis ) return Boolean is
    -- begin
    --     return X.Szmll * Y.Nevez = Y.Szmll * X.Nevez;
    -- end;

end Racionalisok;

